/* Enclosure.c generated by valac 0.52.4, the Vala compiler
 * generated from Enclosure.vala, do not modify */

/*This file is part of FeedReader.*/
/**/
/*FeedReader is free software: you can redistribute it and/or modify*/
/*it under the terms of the GNU General Public License as published by*/
/*the Free Software Foundation, either version 3 of the License, or*/
/*(at your option) any later version.*/
/**/
/*FeedReader is distributed in the hope that it will be useful,*/
/*but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*GNU General Public License for more details.*/
/**/
/*You should have received a copy of the GNU General Public License*/
/*along with FeedReader.  If not, see <http://www.gnu.org/licenses/>.*/

#include "FeedReader.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>

enum  {
	FEED_READER_ENCLOSURE_0_PROPERTY,
	FEED_READER_ENCLOSURE_NUM_PROPERTIES
};
static GParamSpec* feed_reader_enclosure_properties[FEED_READER_ENCLOSURE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

struct _FeedReaderEnclosurePrivate {
	gchar* m_article_id;
	gchar* m_url;
	FeedReaderEnclosureType m_type;
};

static gint FeedReaderEnclosure_private_offset;
static gpointer feed_reader_enclosure_parent_class = NULL;

static void feed_reader_enclosure_finalize (GObject * obj);
static GType feed_reader_enclosure_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
feed_reader_enclosure_get_instance_private (FeedReaderEnclosure* self)
{
	return G_STRUCT_MEMBER_P (self, FeedReaderEnclosure_private_offset);
}

FeedReaderEnclosure*
feed_reader_enclosure_construct (GType object_type,
                                 const gchar* article_id,
                                 const gchar* url,
                                 FeedReaderEnclosureType type)
{
	FeedReaderEnclosure * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (article_id != NULL, NULL);
	g_return_val_if_fail (url != NULL, NULL);
	self = (FeedReaderEnclosure*) g_object_new (object_type, NULL);
	_tmp0_ = g_strdup (article_id);
	_g_free0 (self->priv->m_article_id);
	self->priv->m_article_id = _tmp0_;
	_tmp1_ = g_strdup (url);
	_g_free0 (self->priv->m_url);
	self->priv->m_url = _tmp1_;
	self->priv->m_type = type;
	return self;
}

FeedReaderEnclosure*
feed_reader_enclosure_new (const gchar* article_id,
                           const gchar* url,
                           FeedReaderEnclosureType type)
{
	return feed_reader_enclosure_construct (FEED_READER_TYPE_ENCLOSURE, article_id, url, type);
}

gchar*
feed_reader_enclosure_get_url (FeedReaderEnclosure* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->m_url;
	_tmp1_ = g_strdup (_tmp0_);
	result = _tmp1_;
	return result;
}

FeedReaderEnclosureType
feed_reader_enclosure_get_enclosure_type (FeedReaderEnclosure* self)
{
	FeedReaderEnclosureType _tmp0_;
	FeedReaderEnclosureType result = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->m_type;
	result = _tmp0_;
	return result;
}

static void
feed_reader_enclosure_class_init (FeedReaderEnclosureClass * klass,
                                  gpointer klass_data)
{
	feed_reader_enclosure_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &FeedReaderEnclosure_private_offset);
	G_OBJECT_CLASS (klass)->finalize = feed_reader_enclosure_finalize;
}

static void
feed_reader_enclosure_instance_init (FeedReaderEnclosure * self,
                                     gpointer klass)
{
	self->priv = feed_reader_enclosure_get_instance_private (self);
}

static void
feed_reader_enclosure_finalize (GObject * obj)
{
	FeedReaderEnclosure * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FEED_READER_TYPE_ENCLOSURE, FeedReaderEnclosure);
	_g_free0 (self->priv->m_article_id);
	_g_free0 (self->priv->m_url);
	G_OBJECT_CLASS (feed_reader_enclosure_parent_class)->finalize (obj);
}

static GType
feed_reader_enclosure_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FeedReaderEnclosureClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) feed_reader_enclosure_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FeedReaderEnclosure), 0, (GInstanceInitFunc) feed_reader_enclosure_instance_init, NULL };
	GType feed_reader_enclosure_type_id;
	feed_reader_enclosure_type_id = g_type_register_static (G_TYPE_OBJECT, "FeedReaderEnclosure", &g_define_type_info, 0);
	FeedReaderEnclosure_private_offset = g_type_add_instance_private (feed_reader_enclosure_type_id, sizeof (FeedReaderEnclosurePrivate));
	return feed_reader_enclosure_type_id;
}

GType
feed_reader_enclosure_get_type (void)
{
	static volatile gsize feed_reader_enclosure_type_id__volatile = 0;
	if (g_once_init_enter (&feed_reader_enclosure_type_id__volatile)) {
		GType feed_reader_enclosure_type_id;
		feed_reader_enclosure_type_id = feed_reader_enclosure_get_type_once ();
		g_once_init_leave (&feed_reader_enclosure_type_id__volatile, feed_reader_enclosure_type_id);
	}
	return feed_reader_enclosure_type_id__volatile;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

